/*

 Registrierung von Clipper Softwareapplikationen                  
 und Abfrage nach Benutzername                                    
 Die Funktion unterscheidet ob die Applikation schon              
 mit der extern vergebenen Seriennummer registriert ist           
 und gibt beim Programmaufruf den Bebutzernnamen und Serien-      
 nummer aus oder ob das Programm zum ersten Mal aufgerufen        
 wurde und hier Initialisiert werden mu.                         
 Die Seriennummer wird verschlsselt ins EXE - File eingetragen.  
 FUNCTION BURN_IN     bentigt das externe Programm BURNIN.EXE    
 Autor  : Klaus Mick                                              
 Datum  : 17.7.1991                                               

*/

function burn_in
parameter cmd                          // bergabeparameter = Name des EXE-Files
handle := fopen(alltrim(cmd),2)        // Datei im Modus Lesen/Schreiben ffnen
if handle <0                           // ffnungsfehler
  quit                                 // ENDE
endif
clear screen
buffer  := space(20)                   // Kundenname initialisieren
sbuffer := space(10)                   // Seriennummer initalisieren
fseek(handle,-30,2)                    // Dateizeiger auf -30 Bytes vom Ende positionieren
buffer := freadstr(handle,20)          // 20 Bytes fr Kundennamen einlesen
if empty(buffer)                       // Wenn leer = 1. Aufruf des EXE - Files
  SET SCOREBOARD OFF                   // 
  SET ESCAPE OFF                       // ESC Taste canceln
  buffer := space(20)                  // 20 Leerzeichen besttigen
  @ 15,10 to 18,70                     // Rahmen zeichnen
  @ 15,27 say "Software Registrierung"
  @ 16,17 say "Bitte Namen eingeben >>> " get buffer picture "@K@!" valid f____n(buffer)
* @ 17,17 say "Seriennummer         >>> " get sbuffer picture "xxxxxxxxxx" valid f____s(sbuffer)
  @ 17,17 say "Seriennummer         >>> " get sbuffer valid f____s(sbuffer)
  read
  fseek(handle,-30,2)                  // Dateizeiger auf -30 Bytes vom Ende setzen
  fwrite(handle,buffer,20)             // 20 Bytes aus GET in Datei schreiben
else
  set cursor off
  ? alltrim(upper(cmd))+" ist eingetragen auf den Namen: "+buffer
  fseek(handle,-10,2)                  // Dateizeiger auf -10 Byte vom Ende positionen

/*
  Die Funktion iscrypt(expC,expN) kann mit 10 unterschiedlichen
  Cryptzeigern (expN) ausgestattet werden. Fr die Clipperfunktion
  burn_in ist der Vorgabewert expN = 7 da in dem Hilfsprogramm
  BURNIN.EXE ebenfalls der expN-Schlssel 7 verwendet wurde.
*/

  ? "Seriennummer :"+iscrypt(freadstr(handle,10),7)
  inkey(5)                             // und Seriennummer die mit BURNIN.EXE eingegeben
  set cursor on                        // wurde anzeigen
endif
fclose(handle)                         // Datei schlieen
clear screen
set escape on                          // ESC freisetzen
return .t.                             // Funktion ENDE



***************************************************



function f____n
parameter h____1
if empty(h____1) .or. len(trim(h____1)) <=4
  set cursor off
  @ 18,12 say center("<Name mu mit mindestens 4 Zeichen eingegeben werden.>",56)
  buffer := space(20)
  inkey(3)
  set cursor on
  return .f.
else
  return .t.
endif


function f____s
parameters h____1
fseek(handle,-10,2)
if .not. trim(freadstr(handle,10)) = trim(iscrypt(h____1,7))
  set cursor off
  @ 18,18 say "<Seriennummer ungltig.  Bitte neu eingeben>"
  sbuffer := space(10)
  inkey(3)
  set cursor on
  return .f.
else
  return .t.
endif


function iscrypt
para crypt1,crypt2
if crypt2>9
 crypt2=crypt2-int(crypt2/10)*10
endif
crypt3:=""
crypt4:=0
do while crypt4<len(crypt1)
 crypt2:=crypt2*(-1)
 crypt4:=crypt4+1
 crypt5:=asc(substr(crypt1,crypt4,1))
 crypt5:=255-crypt5+crypt2-(crypt4-int(crypt4/7)*7)
 crypt3:=crypt3+chr(crypt5)
enddo
return(crypt3)
